{-# OPTIONS_HADDOCK show-extensions #-}

-- |
-- Module      :  Phladiprelio.Ukrainian.PropertiesFuncRepG2
-- Copyright   :  (c) Oleksandr Zhabenko 2020-2023
-- License     :  MIT
-- Stability   :  Experimental
-- Maintainer  :  oleksandr.zhabenko@yahoo.com
--
-- Generalization of the functionality of the DobutokO.Poetry.Norms
-- and DobutokO.Poetry.Norms.Extended modules
-- from the @dobutokO-poetry@ package. Instead of vectors, uses arrays.

{-# LANGUAGE NoImplicitPrelude #-}

module Phladiprelio.Ukrainian.PropertiesFuncRepG2 (
  -- * Extended functions
  -- ** Functions with 'Int16'
  procDiverse2ITup
  -- ** Functions with 'Double'
  -- *** More general
  , procB2FGTup
  , procB2InvFGTup
  -- *** Usual ones
  , procDiverse2FTup
  , procBothFTup
  , procBothFFTup
  , procBothInvFTup
  , procBothInvFFTup
  -- *** Working with generated by r-glpk-phonetic-languages-ukrainian-durations syllable durations
  , procBoth2FTup
  , procBoth2FFTup
  , procBoth2InvFTup
  , procBoth2InvFFTup
  -- *** NEW Working with generated by r-glpk-phonetic-languages-ukrainian-durations syllable durations
  , procBoth3FTup
  , procBoth3FFTup
  , procBoth3InvFTup
  , procBoth3InvFFTup
  , procBoth4FTup
  , procBoth4FFTup
  , procBoth4InvFTup
  , procBoth4InvFFTup
  -- ** Working with rhythmicity
  , procRhythmicity23FTup
  -- *** Working with rhythmicity that can be defined by the user (using 'rhythmicityH')
  , procRhythmicity23FHTup
) where

import Phladiprelio.Ukrainian.PropertiesFuncRepG2Common
import Phladiprelio.Ukrainian.PropertiesSyllablesG2Common
import Phladiprelio.Ukrainian.Common
import Phladiprelio.Ukrainian.PropertiesFuncRepG2Diverse
import Phladiprelio.Ukrainian.PropertiesFuncRepG2Rhythmicity
import Phladiprelio.Ukrainian.PropertiesFuncRepG24
