{-# OPTIONS_HADDOCK show-extensions #-}

-- |
-- Module      :  Phladiprelio.Ukrainian.PropertiesSyllablesG2
-- Copyright   :  (c) Oleksandr Zhabenko 2020-2023
-- License     :  MIT
-- Stability   :  Experimental
-- Maintainer  :  oleksandr.zhabenko@yahoo.com
--
-- Generalization and extension of the functionality of the DobutokO.Poetry.Norms
-- and DobutokO.Poetry.Norms.Extended modules
-- from the @dobutokO-poetry@ package. Uses syllables information.
-- Instead of the vector-related, uses just arrays.

{-# LANGUAGE NoImplicitPrelude #-}

module Phladiprelio.Ukrainian.PropertiesSyllablesG2 (
  -- * Rhythmicity properties extended
  -- ** Rhythmicity properties (semi-empirical)
  -- *** General ones
  rhythmicity0HTup
  , rhythmicity0FHTup
  , rhythmicityKHTup
  , rhythmicityKFHTup
  -- *** Simple one
  , rhythmicity0Tup
  , rhythmicity0FTup
  -- *** With weight coefficients
  , rhythmicityKTup
  , rhythmicityKFTup
  -- ** Rhythmicity properties from generated with r-glpk-phonetic-languages-ukrainian-durations package (since 0.2.0.0 version)
  -- *** Simple one
  , rhythmicity02Tup
  , rhythmicity02FTup
  -- *** With weight coefficients
  , rhythmicityK2Tup
  , rhythmicityKF2Tup
  -- ** NEW Rhythmicity properties from generated with r-glpk-phonetic-languages-ukrainian-durations package
  -- *** Simple ones
  , rhythmicity03Tup
  , rhythmicity03FTup
  , rhythmicity04Tup
  , rhythmicity04FTup
  -- *** With weight coefficients
  , rhythmicityK3Tup
  , rhythmicityKF3Tup
  , rhythmicityK4Tup
  , rhythmicityKF4Tup
  -- ** General
  , rhythmicityGTup
  , rhythmicityGHTup
  , rhythmicityTup
  , rhythmicityHTup
  , rhythmicityH'Tup
) where

import Phladiprelio.Ukrainian.PropertiesSyllablesG2Common
import Phladiprelio.Ukrainian.PropertiesSyllablesG201
import Phladiprelio.Ukrainian.PropertiesSyllablesG2H
import Phladiprelio.Ukrainian.PropertiesSyllablesG2Hprime
